dasm_no             equ 0
dasm_oorrrmmm       equ 1               ;lowbyte gecut in tabel !
dasm_ccccoorrrmmm   equ 2               ;lowbyte gecut in tabel !
dasm_woorrrmmm      equ 3               ;lowbyte gecut in tabel !

dasm_mmm            equ 4
dasm_cccc           equ 5
dasm_oommm          equ 6
;dasm_rrrmmm         equ 7
dasm_prefix         equ 7

dasm_woommm         equ 8
dasm_w              equ 9 
dasm_wmmm           equ 10 

dasm_imm32          equ 080h
dasm_imm16          equ 090h
dasm_imm8           equ 0a0h
dasm_imm            equ 0b0h

;----------------------------------------------------------------------------;
dasm_not:           ;normal opcode table

db 0fah
db dasm_wmmm+dasm_imm
db 10110000b                     ;MOV           Reg,imm

db 0fah
db dasm_woorrrmmm
db 00010000b                     ;ADC           Mem,Reg
db 00010010b                     ;ADC           Reg,Mem
db 00000000b                     ;ADD           Mem,Reg
db 00000010b                     ;ADD           Reg,Mem
db 00100010b                     ;AND           Reg,Reg
db 00100000b                     ;AND           Mem,Reg
db 00111010b                     ;CMP           Reg,Reg
db 00111000b                     ;CMP           Mem,Reg
db 10001010b                     ;MOV           Reg,Mem
db 10001000b                     ;MOV           Mem,Reg
db 00001010b                     ;OR            Reg,Reg
db 00001000b                     ;OR            Mem,Reg
db 00011000b                     ;SBB           Mem,Reg
db 00011010b                     ;SBB           Reg,Mem
db 00101000b                     ;SUB           Mem,Reg
db 00101010b                     ;SUB           Reg,Mem
db 10000100b                     ;TEST          Reg,Mem
db 10000110b                     ;XCHG          Reg,Mem
db 00110000b                     ;XOR           Mem,Reg
db 00110010b                     ;XOR           Reg,Mem
db 11010010b                     ;ROL..SAR      Mem,CL
db 11010000b                     ;ROL..SAR      Mem,1

db 0fah
db dasm_oorrrmmm
db 10001101b                     ;LEA           rword,Mem

db 0fah
db dasm_woorrrmmm+dasm_imm8
db 10000010b                     ;ADD..CMP      Mem,imm8
db 11000000b                     ;ROL..SAR      Mem,imm8

db 0fah
db dasm_woorrrmmm+dasm_imm
db 10000000b                     ;ADD...CMP     Mem,imm

db 0fbh
db dasm_woommm+dasm_imm
db 11000110b,00000000b           ;MOV           Mem,imm
db 11110110b,00000000b           ;TEST          Mem,imm

db 0fah
db dasm_cccc+dasm_imm8
db 01110000b                     ;Jcc           imm8

db 0fah
db dasm_imm
db 11101001b                     ;JMP           imm32
db 11101000b                     ;CALL          imm32
db 01101000b                     ;PUSHD         imm

db 0fbh
db dasm_woommm
db 11111110b,00000000b           ;INC           Mem
db 11111110b,00001000b           ;DEC           Mem
db 11110110b,00010000b           ;NOT           Mem
db 11110110b,00011000b           ;NEG           Mem
db 11110110b,00100000b           ;MUL           Mem
db 11110110b,00101000b           ;IMUL          Mem
db 11110110b,00110000b           ;DIV           Mem
db 11110110b,00111000b           ;IDIV          Mem

db 0fbh
db dasm_oommm
db 10001111b,00000000b           ;POP           mword
db 11111111b,00110000b           ;PUSH          mword
db 11111111b,00100000b           ;JMP           rword
db 11111111b,00010000b           ;CALL          rword

db 0fah
db dasm_no
db 11001100b                     ;INT           3
db 11000011b                     ;RET           near
db 00110111b                     ;AAA           <NO>
db 00111111b                     ;AAS           <NO>
db 10011000b                     ;CBW           <NO>
db 10011001b                     ;CDQ           <NO>
db 11111000b                     ;CLC           <NO>
db 11111100b                     ;CLD           <NO>
db 11110101b                     ;CMC           <NO>
cmpsb
cmpsd
db 10011001b                     ;CWD           <NO>
db 10011000b                     ;CWDE          <NO>
db 00100111b                     ;DAA           <NO>
db 00101111b                     ;DAS           <NO>
db 10011111b                     ;LAHF          <NO>
db 11001001b                     ;LEAVE         <NO>
lodsb
lodsd
movsb
movsd
db 10010000b                     ;NOP           <NO>
db 01100001b                     ;POPAD         <NO>
db 10011101b                     ;POPFD         <NO>
db 01100000b                     ;PUSHAD        <NO>
db 10011100b                     ;PUSHFD        <NO>
db 11010110b                     ;SALC          <NO>
db 10011110b                     ;SAHF          <NO>
scasb
scasd
db 11111001b                     ;STC           <NO>
db 11111101b                     ;STD           <NO>
stosb
stosd
db 11010111b                     ;XLAT          <NO>

db 0fah
db dasm_prefix
db 11110011b                     ;REP           <NO>
db 11110010b                     ;REPNE         <NO>
db 00101110b                     ;CS:           <NO>
db 00111110b                     ;DS:           <NO>
db 00100110b                     ;ES:           <NO>
db 01100100b                     ;FS:           <NO>
db 01100101b                     ;GS:           <NO>

db 0fah
db dasm_imm8
db 11100011b                     ;JECXZ         imm8
db 11101011b                     ;JMP           imm8
db 11100010b                     ;LOOP          imm8
db 11100001b                     ;LOOPZ         imm8
db 11100000b                     ;LOOPNE        imm8
db 11010101b                     ;AAD           imm8
db 11010100b                     ;AAM           imm8
db 01101010b                     ;PUSH          imm8

db 0fah
db dasm_w+dasm_imm
db 00001100b                     ;OR            Acc,imm
db 00011100b                     ;SBB           Acc,imm
db 00101100b                     ;SUB           Acc,imm
db 10101000b                     ;TEST          Acc,imm
db 00110100b                     ;XOR           Acc,imm
db 00010100b                     ;ADC           Acc,imm
db 00000100b                     ;ADD           Acc,imm
db 00100100b                     ;AND           Acc,imm
db 00111100b                     ;CMP           Acc,imm

db 0fah
db dasm_mmm
db 01011000b                     ;POP           rword
db 01010000b                     ;PUSH          rword
db 10010000b                     ;XCHG          rwo,AccWo
db 01001000b                     ;DEC           rword
db 01000000b                     ;INC           rword

;enter hardcoded checking
;db dasm_imm8
;db 11001000b                     ;ENTER         imm16,imm8

db 0fah
db dasm_imm16
db 11000010b                     ;RET           imm16 near

db 0fah
db dasm_imm32+dasm_w
db 10100010b                     ;MOV           MemOfs,Acc
db 10100000b                     ;MOV           Acc,MemOfs

db 0fah
db dasm_oorrrmmm+dasm_imm8
db 01101011b                     ;IMUL          rwo,mwo,imm8

db 0fah
db dasm_oorrrmmm+dasm_imm
db 01101001b                     ;IMUL          rwo,mwo,imm

db 0fah
db 0fah

db 1000100b
db 1000001b
db 1010011b
db 1001101b
db 0101101b
db 1001100b
db 1010111b
db 0101111b
db 1001001b
db 1001011b
db 1011000b

;----------------------------------------------------------------------------;

dasm_eot:   ;extended opcode tabel (0f)

db 0fah
db dasm_cccc+dasm_imm32
db 10000000b           ;Jcc           imm32

db 0fah
db dasm_ccccoorrrmmm
db 10010000b           ;SETcc         Mem8
db 01000000b           ;CMOVcc        Reg,Reg

db 0fah
db dasm_oorrrmmm+dasm_imm8
db 10111010b           ;BT            rword,imm8
db 10100100b           ;SHLD          rwo,rwo,I8
db 10101100b           ;SHRD          rwo,rwo,I8

db 0fah
db dasm_woorrrmmm
db 10110000b           ;CMPXCHG       Reg,Reg
db 11000000b           ;XADD          Mem,Reg

db 0fah
db dasm_oorrrmmm
db 10111100b           ;BSF           rword,rword
db 10111101b           ;BSR           rword,rword
db 10100011b           ;BT            rword,rword
db 10111011b           ;BTC           rword,rword
db 10110011b           ;BTR           rword,rword
db 10101011b           ;BTS           rword,rword
db 10101111b           ;IMUL          rword,rword
db 00000010b           ;LAR           rword,mword
db 10111110b           ;MOVSX         rword,Mem8
db 10111111b           ;MOVSX         rword,Mem16
db 10110110b           ;MOVZX         rword,Mem8
db 10110111b           ;MOVZX         rword,Mem16
db 10100101b           ;SHLD          rwo,rwo,CL
db 10101101b           ;SHRD          rwo,rwo,CL

db 0fah
db dasm_mmm
db 11001000b           ;BSWAP         rword

db 0fah         ;double terminator is the symbol of death
db 0fah

;----------------------------------------------------------------------------;

dasm_masklo:
db      11111111b
db      00000000b
db      00000000b
db      00000000b
db      11111111b
db      11111111b
db      00111000b       ;6
db      11000000b
db      00111000b
db      11111111b
db      11111111b

dasm_maskhi:
db      11111111b
db      11111111b
db      11110000b
db      11111110b
db      11111000b
db      11110000b
db      11111111b       ;6
db      11111111b
db      11111110b
db      11111110b
db      11110000b

